package de.juplo.demos.multiplebeans;

import lombok.AllArgsConstructor;
import org.springframework.beans.factory.config.ConfigurableListableBeanFactory;
import org.springframework.context.ApplicationContextInitializer;
import org.springframework.context.ConfigurableApplicationContext;

@AllArgsConstructor
public class MultipleBeansApplicationContextInitializer
        implements
        ApplicationContextInitializer<ConfigurableApplicationContext> {

    private final String[] sites;


    @Override
    public void initialize(ConfigurableApplicationContext context) {
        ConfigurableListableBeanFactory factory = context.getBeanFactory();
        for (String site : sites) {
            SiteController controller = new SiteController(site, "Descrition of site " + site);
            factory.registerSingleton("/" + site, controller);
        }
    }
}
