package de.juplo.demos.multiplebeans;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.env.EnvironmentPostProcessor;
import org.springframework.core.env.ConfigurableEnvironment;

import java.util.Arrays;

public class MultipleBeansEnvironmentPostProcessor implements EnvironmentPostProcessor {

    @Override
    public void postProcessEnvironment(ConfigurableEnvironment environment, SpringApplication application) {
        String sites = environment.getRequiredProperty("juplo.sites", String.class);

        application.addInitializers(new MultipleBeansApplicationContextInitializer(
                Arrays.stream(sites.split(","))
                .map(site -> site.trim())
                .toArray(size -> new String[size])));
    }
}